/*
 * Author:	 Weaver Hastings
 * File Name:	 myint.cpp
 * Course:	 COP3330
 * Section:	 3
 * Due Date:     10/08/2010
 * Description:  This program doesn't work.  The multiplication and
 *               addition work, most of the program works.  I have
 *               been plagued by memory problems from the beginning.
 *               Once I fixed the memory problem with the addition
 *               and finished writting the part for the mulitiplication
 *               it popped up again.  The program does compile it
 *               just crashes after trying to multiply an integer
 *               times a myint object.  Can't trace it and am out of
 *               time.
 */
#include <iostream>
#include <cstring>
#include "myint.h"
using namespace std;

// Constructor for C-Style strings.
MyInt::MyInt(const char* n)
{
    int length, i = 0;    
    char ch;
    
    max = 5;
    size = 0;
    array = new unsigned int[max];

    length = strlen(n);

    while(i < length)
    {
        if(size == max)
            Grow();
        
        if(C2I(n[i]) == -1)
        {
            array[0] = 0;
            size = 1;
            max = 5;
            break;
        }        
        else
        {
            array[i] = C2I(n[i]);
            size++;
        }
        i++;
    }
}
// Overload of the multiplication operator.
MyInt operator* (const MyInt& x, const MyInt& y)
{
    MyInt result, temp;
    result.size = 0;
    temp.size = 0;
    
    if(x.size > y.size)
    {
        int carry = 0,
            tmpResult,
            iterance = 0;
        
        for(int i = y.size-1; i >= 0; i--)
        {
            // If it's not the first digit in the multiplier
            // add the appropriate number of zeros.
            if(iterance > 0)
            {
                for(int k = 0; k < iterance; k++)
                {
                    temp.array[k] = 0;
                    temp.size++;
                }
            }
            for(int j = x.size-1; j >= 0; j--)
            {
                tmpResult = y.array[i] * x.array[j] + carry;
                carry = 0;
                
                if(tmpResult > 9)
                {
                    // Incase we're at the most signifigant digit.
                    if(j == 0)
                    {
                        temp.array[temp.size++] = tmpResult/10;
                        temp.array[temp.size++] = tmpResult%10;
                    }
                    // If we're not.
                    else
                    {
                        temp.array[temp.size++] = tmpResult%10;
                        carry = tmpResult/10;
                    }
                }
                // If the number doesn't need a carry.
                else
                {
                    temp.array[temp.size++] = tmpResult;
                }

                // Check if we need to increase the size of the array.
                if(temp.size == temp.max)
                    temp.Grow();
            }
            iterance++;
            
            // Reverse the order of the number.
            temp.Reverse();
            // Add the temporary result to the total result.
            result = result+temp;
            // Reset the size of the temporary array.
            temp.size = 0;
        }
    }    
    else if(x.size <= y.size)
    {
        int carry = 0,
            tmpResult,
            iterance = 0;
        
        for(int i = x.size-1; i >= 0; i--)
        {
            // If it's not the first digit in the multiplier
            // add the appropriate number of zeros.
            if(iterance > 0)
            {
                for(int k = 0; k < iterance; k++)
                {
                    temp.array[k] = 0;
                    temp.size++;
                }
            }
            for(int j = y.size-1; j >= 0; j--)
            {
                tmpResult = y.array[j] * x.array[i] + carry;
                carry = 0;
                
                if(tmpResult > 9)
                {
                    // Incase we're at the most signifigant digit.
                    if(j == 0)
                    {
                        temp.array[temp.size++] = tmpResult/10;
                        temp.array[temp.size++] = tmpResult%10;
                    }
                    // If we're not.
                    else
                    {
                        temp.array[temp.size++] = tmpResult%10;
                        carry = tmpResult/10;
                    }
                }
                // If the number doesn't need a carry.
                else
                {
                    temp.array[temp.size++] = tmpResult;
                }

                // Check if we need to increase the size of the array.
                if(temp.size == temp.max)
                    temp.Grow();
            }
            iterance++;
            
            // Reverse the order of the number.
            temp.Reverse();
            // Add the temporary result to the total result.
            result = result+temp;
            // Reset the size of the temporary array.
            temp.size = 0;
        }
    }    
    return result;
}

// Overload of the addition operator.
MyInt operator+ (const MyInt& x, const MyInt& y)
{
    MyInt result;
    result.size = 0;
    
    if(x.size > y.size)
    {
        int diff = x.size - y.size;
        int tmpResult,
            carry = 0;

        for(int i = y.size-1; i >= 0; i--)
        {
            tmpResult = y.array[i] + x.array[i+diff] + carry;
            carry = 0;
            if(tmpResult > 9)
            {
                result.array[result.size++] = tmpResult%10;
                carry = tmpResult/10;
            }
            else
            {
                result.array[result.size++] = tmpResult;
            }
            if(result.size == result.max)
                result.Grow();
        }
        
        for(int k = diff-1; k >= 0; k--)
        {
            tmpResult = x.array[k] + 0 + carry;
            
            carry = 0;
            if(tmpResult > 9)
            {
                result.array[result.size++] = tmpResult%10;
                carry = tmpResult/10;
            }
            else
            {
                result.array[result.size++] = tmpResult;
            }
            if(result.size == result.max)
                result.Grow();
        }
    }
    else if(y.size > x.size)
    {
        int diff = y.size - x.size;
        int j = 0,
            tmpResult,
            carry = 0;
        for(int i = x.size-1; i >= 0; i--)
        {
            tmpResult = y.array[i+diff] + x.array[i] + carry;
            
            carry = 0;
            if(tmpResult > 9)
            {
                result.array[result.size++] = tmpResult%10;
                carry = tmpResult/10;
            }
            else
            {
                result.array[result.size++] = tmpResult;
            }
            if(result.size == result.max)
                result.Grow();
        }

        for(int k = diff-1; k >= 0; k--)
        {
            tmpResult = y.array[k] + 0 + carry;
            
            carry = 0;
            if(tmpResult > 9)
            {
                result.array[result.size++] = tmpResult%10;
                carry = tmpResult/10;
            }
            else
            {
                result.array[result.size++] = tmpResult;
            }
            if(result.size == result.max)
                result.Grow();
        }
    }
    // Calculate the result if x and y are the same size.
    else
    {
        int tmpResult,
            carry = 0,
            j = 0;
        
        for(int i = x.size-1; i >= 0; i--)
        {
            tmpResult = y.array[i] + x.array[i] + carry;

            carry = 0;
            if(tmpResult > 9)
            {
                result.array[result.size++] = tmpResult%10;
                carry = tmpResult/10;
            }
            
            else
            {
                result.array[result.size++] = tmpResult;
            }
            
            if(result.size == result.max)
                result.Grow();
        }
    }
    result.Reverse();
    return result;
}

void MyInt::Reverse()
{
    if(size%2 == 0)
    {
        for(int j = 0; j < size/2; j++)
        {
            int tmp;
            tmp = array[j];
            array[j] = array[(size-1)-j];
            array[(size-1)-j] = tmp;
        }
    }
    else
    {
        for(int k = 0; k < ((size-1)/2); k++)
        {
            int tmp;
            tmp = array[k];
            array[k] = array[(size-1)-k];
            array[(size-1)-k] = tmp;
        }
    }
}

MyInt::MyInt(int n)
{
    size = 0;
    max = 5;
    array = new unsigned int[max];
    
    if(n <= 0)
    {
        array[0] = 0;
        size = 0;
    }
    else
    {
        int i = 0;
        while(n != 0)
        {
            array[i] = n % 10;
            n = n/10;
            size++;

            if(size == max)
               Grow();
            i++;
        }

        Reverse();
    }
}

// Destructor.
MyInt::~MyInt()
{
    delete [] array;
}

// Copy Constructor.
MyInt::MyInt(const MyInt& n)
{
    array = new unsigned int[n.size];
    size = n.size;
    max = n.max;

    for(int i = 0; i < size; i++)
        array[i] = n.array[i];
}

MyInt& MyInt::operator= (const MyInt& n)
{
    if(this != &n)
    {
        // Create an array to copy data to before deleting array
        // incase an exception is thrown.
        unsigned int *temp = new unsigned int[n.size];
        for(int i = 0; i < n.size; i++)
            temp[i] = n.array[i];

        // Delete the old array.
        delete [] array;
        // Assign the new array pointer to original.
        array = temp;
        // Assign the size information.        
        size = n.size;
        max = n.max;
    }
    return *this;
}

void MyInt::Grow()
{
    max = size + 5;
    unsigned int *temp = new unsigned int[max];

    for(int i = 0; i < size; i++)
       temp[i] = array[i];
    delete  [] array;
    array = temp;
}

// Overload of the insertion operator.
ostream& operator<< (ostream& outs, const MyInt& n)
{
    if(n.size == 0)
    {
        outs << 0;
    }
    else
    {
        // Put each int in the output stream.
        for(int i = 0; i < n.size; i++)
        {
            outs << n.array[i];
        }
        // Return the stream to caller.
    }
    return outs;
}

// Overload of the exctraction operator.
istream& operator>> (istream& ins, MyInt& n)
{
    char ch;
    n.size = 0;
    n.max = 5;
    
    // Get the first character.
    ch = ins.peek();

    while(!isdigit(ch))
    {
        ins.ignore();
        ch = ins.peek();
    }
    
    while(isdigit(ch))
    {
        ins.get(ch);        
        n.array[n.size] = n.C2I(ch);
        n.size++;
        ch = ins.peek();
        
        if(n.size == n.max)
            n.Grow();        
    }
    return ins;
}

// converts character into integer (returns -1 for error)
int MyInt::C2I(char c)
{
   if (c < '0' || c > '9')
       return -1;                     // Error
   
   return (c - '0');		      // Success
}

//********************************************
// The following functions are the relational* 
// operator overloads.  There are two member *
// functions that are used by the overloaded *
// friend functions to get the result.       *
// *******************************************

bool MyInt::LessThan(const MyInt& rhs) const
{
    bool status = false;

    if(size < rhs.size)
    {
        status = true;
    }
    else if(size == rhs.size)
    {
        for(int i = 0; i < size; i++)
        {
            if(array[i] < rhs.array[i])
                status = true;
        }
    }
    return true;
}

bool MyInt::Equal(const MyInt& rhs) const
{
    bool status = true;

    if(size == rhs.size)
    {
        for(int i = 0; i < size; i++)
        {
            if(array[i] != rhs.array[i])
                status = false;
        }
    }
    else
        status = false;
    return status;
}

bool operator== (const MyInt& lhs, const MyInt& rhs)
{
    return lhs.Equal(rhs);
}

bool operator< (const MyInt& lhs, const MyInt& rhs)
{
    return lhs.LessThan(rhs);
}

bool operator!= (const MyInt& lhs, const MyInt& rhs)
{
    return !(lhs == rhs);
}

bool operator> (const MyInt& lhs, const MyInt& rhs)
{
    return rhs < lhs;
}

bool operator<= (const MyInt& lhs, const MyInt& rhs)
{
    return ! (lhs > rhs);
}

bool operator>= (const MyInt& lhs, const MyInt& rhs)
{
    return rhs <= lhs;
}

//*******************************************
// Overloaded unary operators               *
// ******************************************

MyInt MyInt::operator++ ()
{
    *this = *this+1;
    return *this;
}

MyInt MyInt::operator++ (int)
{
    MyInt temp;
    temp = *this;
    temp = temp+1;
    *this = temp;
    return temp;
}
