/*
 * Author:	 Weaver Hastings
 * File Name:	 myint.h
 * Course:	 COP3330
 * Section:	 3
 * Due Date:     10/08/2010
 * Description:  This program doesn't work.  The multiplication and
 *               addition work, most of the program works.  I have
 *               been plagued by memory problems from the beginning.
 *               Once I fixed the memory problem with the addition
 *               and finished writting the part for the mulitiplication
 *               it popped up again.  The program does compile it
 *               just crashes after trying to multiply an integer
 *               times a myint object.  Can't trace it and am out of
 *               time.
 */
#ifndef MYINT_H
#define MYINT_H

#include <iostream>
using namespace std;

class MyInt
{
    friend MyInt operator+ (const MyInt& x, const MyInt& y);
    friend MyInt operator* (const MyInt& x, const MyInt& y);
    friend bool operator<  (const MyInt& x, const MyInt& y);
    friend bool operator>  (const MyInt& x, const MyInt& y);
    friend bool operator== (const MyInt& x, const MyInt& y);
    friend bool operator!= (const MyInt& x, const MyInt& y);
    friend bool operator>= (const MyInt& x, const MyInt& y);
    friend bool operator<= (const MyInt& x, const MyInt& y);   
    friend ostream& operator << (ostream& outs, const MyInt& n);
    friend istream& operator >> (istream& ins, MyInt& n);
    
  public:
    MyInt(int n = 0);         // Default Constructor.
    MyInt(const MyInt& n);    // Copy Constructor.
    MyInt(const char* n);              // Constructor for C-Style array.
    ~MyInt();                 // Destructor.
    void Reverse();           // Function to reverse the order of array.
    
    // Overload of assignment operator.
    MyInt& operator= (const MyInt& n);
    
    // Equal function is for use with the friend comparison overloads.
    bool Equal(const MyInt& rhs) const;
    
    // LessThan is for use with the friend comparison overloads.
    bool LessThan(const MyInt& rhs) const;

    // Member operator overloads.
    MyInt operator ++ ();        // Prefix ++
    MyInt operator ++ (int);     // Postfix ++
    MyInt operator -- ();        // Prefix --
    MyInt operator -- (int);     // Postfix --
    
  private:
    int C2I(char c);            // To convert char to int.
    
    void Grow();                // To increase size of the array.
    
    unsigned int size,          // Current size of the array.
                 max,           // Max size of array.
                 *array;        // For dynamic array.
    
    
    
};

#endif
